#!/usr/bin/perl

# ---------------------------------------------------------
# Programm: getipaddr.pl
# Version:  0.1
# Synopsis: To retrieve the dynamic IP address
#           PERL script demo for PI3 Web server 
# Author:   Holger Zimmermann
# ---------------------------------------------------------
# web:      http://home.t-online.de/home/zimpel@t-online.de
# mailto:   zimpel@t-online.de
# ---------------------------------------------------------
# calling conventions
#
# URL:      /cgi-bin/getipaddr.pl                       (use mode 0)
# SSI:      <!--exec virtual="/cgi-bin/getipaddr.pl"--> (use mode 1)

use pi3lib;

##########################################
# configuration options, change values   #
# due to your local server configuration #
##########################################

# the installation directory
# $maindir = "/your-path/";
$maindir = ".\\";

# file location where to store the ip-address
#
# $ipaddrfile = $maindir."ipaddr.txt";
$ipaddrfile = $maindir."ipaddr.txt";

# homepage url with placeholder
# $url = "http://IPADDRESS/";
$url = "http://IPADDRESS/";

# token to detect not connected host
# $noip = "not";
$noip = "not";

# mode
# 0 = create page with link
# 1 = create meta tag for automatic switch
$mode = 1;

############################
#      main routine        #
############################

# print the magic header
print "Content-type: text/html\n\n"; 

# create file
CheckFiles($ipaddrfile);

CheckLock(Lock($ipaddrfile));
open(IPFILE, $ipaddrfile) || HandleError('cannot_open', $ipaddrfile);
while (<IPFILE>) {
   $ipaddr = $_ || "Can't read IP address";
   last;
};
close(IPFILE) || HandleError('cannot_close', $ipaddrfile);
CheckLock(Unlock($ipaddrfile));

if ($ipaddr =~ /$noip/i) {
   printf("The web server is %s.", $ipaddr);
}
else {
   $url =~ s /IPADDRESS/$ipaddr/gie;
   if ($mode) {
      print "<HEAD>";
      printf("<meta http-equiv=\"refresh\" content=\"0; URL=%s\">", $url);
      print "</HEAD>";
   }
   else {
      printf("Visit my web site <A HREF=\"%s\">%s</A>", $url, $url);
   };
};


