#!/usr/bin/perl

# ---------------------------------------------------------
# Programm: setipaddr.pl
# Version:  0.1
# Synopsis: To store the dynamic IP address
#           PERL script demo for PI3 Web server 
# Author:   Holger Zimmermann
# ---------------------------------------------------------
# web:      http://home.t-online.de/home/zimpel@t-online.de
# mailto:   zimpel@t-online.de
# ---------------------------------------------------------
# calling conventions
#
# Form :      <FORM METHOD=POST ACTION="/cgi-bin/setipaddr.pl?ipaddr">

use pi3lib;

##########################################
# configuration options, change values   #
# due to your local server configuration #
##########################################

# the installation directory
# $maindir = "/your-path/";
$maindir = ".\\";

# file location where to store the ip-address
#
# $ipaddrfile = $maindir."ipaddr.txt";
$ipaddrfile = $maindir."ipaddr.txt";


###############################
# get form parameters from    #
# environment or input device #
###############################

if ($ENV{'CONTENT_LENGTH'}) { read(STDIN, $ipaddr, $ENV{'CONTENT_LENGTH'}); }
else { $ipaddr = $ENV{'QUERY_STRING'}; };


############################
#      main routine        #
############################

# print the magic header
print "Content-type: text/html\n\n"; 

# create file
CheckFiles($ipaddrfile);

CheckLock(Lock($ipaddrfile));
open(IPFILE, ">$ipaddrfile") || HandleError('cannot_open', $ipaddrfile);
print IPFILE UrlDecode($ipaddr);
close(IPFILE) || HandleError('cannot_close', $ipaddrfile);
CheckLock(Unlock($ipaddrfile));
